<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00001000PropostaLocalAtendFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }

    /**
     * A função "validaLocalAtend" verifica se o local de Atendimento 
     * que está sendo relacionado já está relacionado na tabela.
     */
    
    public function validaLocalAtend($params){
        
        $sql = "SELECT COUNT(*) AS VALIDA
                  FROM FCT_RELACESTRUTURAPROP
                 WHERE NRESTRUTURAM = :NRESTRUTURAM
                   AND NRSEQORCAMENTO = :NRSEQORCAMENTO
                   AND NRITEMORCAMENTO IS NULL
                   AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $return = $std->fetchAll();
        return $return;
    }
    
    /**
     * A função "deletarPaieFilhos" exclui  o local de Atendimento 
     * e os filhos.
     */
     
    public function deletarPaieFilhos($params){
       
        $sqlDeleteFilhos = "DELETE FROM FCT_RELACESTRUTURAPROP
                 WHERE NRORG      = :NRORG
                 AND NRSEQORCAMENTO = :NRSEQORCAMENTO
                 AND IDRELACESTRUTURA = 'PROPOSTA'
                 AND (NRESTRUTURAM = :NRESTRUTURAM 
                            OR NRRELACESTRUTPROP IN (SELECT FCT_RELACESTRUTURAPROP.NRRELACESTRUTPROP
                                                FROM FCT_RELACESTRUTURAPROP
                                                 JOIN HIERARQUIAORG 
                                                  ON FCT_RELACESTRUTURAPROP.NRESTRUTURAM = HIERARQUIAORG.NRESTRUTURAMREL
                                                 AND FCT_RELACESTRUTURAPROP.NRORG = HIERARQUIAORG.NRORG
                                                 WHERE HIERARQUIAORG.NRORG  = :NRORG
                                               START WITH HIERARQUIAORG.NRESTRUTURAMSUP = :NRESTRUTURAM
                                              CONNECT BY PRIOR HIERARQUIAORG.NRESTRUTURAMSUP = HIERARQUIAORG.NRESTRUTURAMREL))";

        $stdDeleteFilhos = $this->connection->prepare($sqlDeleteFilhos);
        $stdDeleteFilhos->execute($params);
    }
}